import * as i0 from '@angular/core';
import { Injectable, Component, ViewEncapsulation, Input, NgModule } from '@angular/core';
import * as i2 from '@angular/forms';
import { NG_VALUE_ACCESSOR, FormsModule } from '@angular/forms';
import * as i1 from '@angular/common';
import { CommonModule, NgTemplateOutlet } from '@angular/common';
import * as i3 from 'primeng/inputtext';
import { InputTextModule } from 'primeng/inputtext';
import * as i4 from 'primeng/fieldset';
import { FieldsetModule } from 'primeng/fieldset';
import * as i5 from 'primeng/api';
import * as i6 from 'primeng/radiobutton';
import { RadioButtonModule } from 'primeng/radiobutton';
import * as i7 from 'primeng/checkbox';
import { CheckboxModule } from 'primeng/checkbox';
import * as i8 from 'primeng/dropdown';
import { DropdownModule } from 'primeng/dropdown';
import * as i9 from 'primeng/divider';
import { DividerModule } from 'primeng/divider';
import * as i10 from 'primeng/tabview';
import { TabViewModule } from 'primeng/tabview';
import { InputNumberModule } from 'primeng/inputnumber';
import { KeyFilterModule } from 'primeng/keyfilter';

class NgxCrontabBuilderService {
    constructor() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

const en = {
    at: "at",
    day: "day",
    day_fri: "Fri",
    day_friday: "Friday",
    day_mon: "Mon",
    day_monday: "Monday",
    day_sat: "Sat",
    day_saturday: "Saturday",
    day_sun: "Sun",
    day_sunday: "Sunday",
    day_thu: "Thu",
    day_thursday: "Thursday",
    day_tue: "Tue",
    day_tuesday: "Tuesday",
    day_wed: "Wed",
    day_wednesday: "Wednesday",
    last_weekday_of_month_option: "Use last weekday of the month if last day of the month is in the weekend",
    month: "month",
    nearest_weekday_option: "Use nearest weekday if selected day is in the weekend",
    of_the_week_at: "of the week at",
    of_the_month_at: "of the month at",
    ord_1: "1st",
    ord_2: "2nd",
    ord_3: "3rd",
    ord_4: "4th",
    ord_5: "5th",
    run_every_day_at: "Run every day at",
    run_every_week_on_day: "Run every week on day",
    run_every_month_on_day: "Run every month on day",
    run_on_last_day_of_month: "Run on the last day of each month, at",
    time_format_info: "(starting time in HH:MM format)",
    use_custom_crontab: "Use the following custom CRON expression",
    week: "week",
    header_every_x_seconds: "Every X seconds",
    header_every_x_minutes: "Every X minutes",
    header_every_x_hours: "Every X hours",
    header_every_day: "Every day",
    header_every_week: "Every week",
    header_every_nth_day: "Every nth day of the week",
    header_every_month: "Every month",
    header_every_last_day_of_month: "On the last day of the month",
    header_custom_cron: "Custom CRON expression",
    run_every: "Run every",
    hours: "hours",
    minutes: "minutes",
    seconds: "seconds"
};

const it = {
    header_every_x_seconds: "Ogni X secondi",
    header_every_x_minutes: "Ogni X minuti",
    header_every_x_hours: "Ogni X ore",
    header_every_day: "Ogni giorno",
    header_every_week: "Ogni settimana",
    header_every_nth_day: "Ogni n-esimo giorno della settimana",
    header_every_month: "Ogni mese",
    header_every_last_day_of_month: "L'ultimo giorno del mese",
    header_custom_cron: "Espressione CRON personalizzata",
    run_every: "Esegui ogni",
    hours: "ore",
    minutes: "minuti",
    seconds: "secondi",
    at: "alle",
    day: "giorno",
    day_fri: "Ven",
    day_friday: "Venerdì",
    day_mon: "Lun",
    day_monday: "Lunedì",
    day_sat: "Sab",
    day_saturday: "Sabato",
    day_sun: "Dom",
    day_sunday: "Domenica",
    day_thu: "Gio",
    day_thursday: "Giovedì",
    day_tue: "Mar",
    day_tuesday: "Martedì",
    day_wed: "Mer",
    day_wednesday: "Mercoledì",
    last_weekday_of_month_option: "Usa l'ultimo giorno feriale del mese se l'ultimo giorno del mese è festivo",
    month: "mese",
    nearest_weekday_option: "Usa il giorno feriale più vicino se il giorno selezionato è festivo",
    of_the_week_at: "della settimana alle",
    of_the_month_at: "del mese alle",
    ord_1: "Primo",
    ord_2: "Secondo",
    ord_3: "Terzo",
    ord_4: "Quarto",
    ord_5: "Quinto",
    run_every_day_at: "Esegui ogni giorno alle",
    run_every_week_on_day: "Esegui ogni settimana il",
    run_every_month_on_day: "Esegui ogni mese il giorno",
    run_on_last_day_of_month: "Esegui l'ultimo giorno di ogni mese alle",
    time_format_info: "(ora di inizio nel formato HH:MM)",
    use_custom_crontab: "Usa la seguente espressione CRON personalizzata",
    week: "settimana",
};

class TranslateService {
    constructor(locale) {
        this.locales = {
            'en': en,
            'it': it
        };
        this.updateLocale(locale);
    }
    updateLocale(locale) {
        this.localeCode = locale;
        this.locale = this.locales[locale];
        this.localizedWeekOrdinals = [
            { value: '1', label: this.locale.ord_1 },
            { value: '2', label: this.locale.ord_2 },
            { value: '3', label: this.locale.ord_3 },
            { value: '4', label: this.locale.ord_4 },
            { value: '5', label: this.locale.ord_5 },
        ];
        this.localizedWeekDays = [
            { value: 'MON', label: this.locale.day_monday },
            { value: 'TUE', label: this.locale.day_tuesday },
            { value: 'WED', label: this.locale.day_wednesday },
            { value: 'THU', label: this.locale.day_thursday },
            { value: 'FRI', label: this.locale.day_friday },
            { value: 'SAT', label: this.locale.day_saturday },
            { value: 'SUN', label: this.locale.day_sunday },
        ];
    }
    get(locale) {
        return this.locales[locale];
    }
}

var CrontabMode;
(function (CrontabMode) {
    CrontabMode["EVERY_X_SECONDS"] = "EVERY_X_SECONDS";
    CrontabMode["EVERY_X_MINUTES"] = "EVERY_X_MINUTES";
    CrontabMode["EVERY_X_HOURS"] = "EVERY_X_HOURS";
    CrontabMode["EVERY_DAY"] = "EVERY_DAY";
    CrontabMode["EVERY_WEEK"] = "EVERY_WEEK";
    CrontabMode["NTH_WEEKDAY"] = "NTH_WEEKDAY";
    CrontabMode["EVERY_MONTH"] = "EVERY_MONTH";
    CrontabMode["LAST_DAY_OF_MONTH"] = "LAST_DAY_OF_MONTH";
    CrontabMode["CUSTOM"] = "CUSTOM";
})(CrontabMode || (CrontabMode = {}));

class CrontabModel {
    constructor(init) {
        Object.assign(this, init);
    }
}

const constants = {
    regex1to59: /^([0-5][0-9]|[1-9])$/,
    regex1to23: /^(1[0-9]|2[0-3]|[1-9])$/,
    regex1to31: /^(3[0-1]|1[0-9]|2[0-3]|[1-9])$/,
    timestampRegex: /^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/,
    initialCrontab: "0/1 * * 1/1 * ?",
    defaultLocale: 'en'
};

class CrontabService {
    updateModel(model) {
        switch (model.mode) {
            case CrontabMode.EVERY_X_SECONDS:
                this.computeEverySecondCrontab(model);
                break;
            case CrontabMode.EVERY_X_MINUTES:
                this.computeEveryMinuteCrontab(model);
                break;
            case CrontabMode.EVERY_X_HOURS:
                this.computeEveryHourCrontab(model);
                break;
            case CrontabMode.EVERY_DAY:
                this.computeEveryDayCrontab(model);
                break;
            case CrontabMode.EVERY_WEEK:
                this.computeEveryWeekDayCrontab(model);
                break;
            case CrontabMode.NTH_WEEKDAY:
                this.computeEveryNthDayOfWeekCrontab(model);
                break;
            case CrontabMode.EVERY_MONTH:
                this.computeNDayInMonthCrontab(model);
                break;
            case CrontabMode.LAST_DAY_OF_MONTH:
                this.computeLastMonthDay(model);
                break;
            case CrontabMode.CUSTOM:
                this.computeCustom(model);
                break;
        }
    }
    parse(crontab, customMode) {
        if (this.isNullOrWhiteSpace(crontab)) {
            return new CrontabModel({
                mode: CrontabMode.CUSTOM
            });
        }
        if (customMode) {
            return new CrontabModel({
                mode: CrontabMode.CUSTOM,
                customCrontabString: crontab
            });
        }
        //Every X seconds mode
        let re = /0\/([0-9]|[0-5][0-9]) \* \* 1\/1 \* \?/;
        if (re.test(crontab)) {
            return new CrontabModel({
                mode: CrontabMode.EVERY_X_SECONDS,
                outputCrontabString: crontab,
                secondModeSeconds: re.exec(crontab)[1]
            });
        }
        //Every X minutes mode
        re = /0 0\/([0-9]|[0-5][0-9]) \* 1\/1 \* \?/;
        if (re.test(crontab)) {
            return new CrontabModel({
                mode: CrontabMode.EVERY_X_MINUTES,
                outputCrontabString: crontab,
                minuteModeMinutes: re.exec(crontab)[1]
            });
        }
        //Every X hours mode
        re = /0 0 0\/([0-9]|[0-2][0-9]) 1\/1 \* \?/;
        if (re.test(crontab)) {
            return new CrontabModel({
                mode: CrontabMode.EVERY_X_HOURS,
                outputCrontabString: crontab,
                hourlyModeHours: re.exec(crontab)[1]
            });
        }
        //Every day mode
        re = /0 ([0-9]|[0-5][0-9]) ([0-9]|[0-2][0-9]) \* \* \?/;
        if (re.test(crontab)) {
            return new CrontabModel({
                mode: CrontabMode.EVERY_DAY,
                outputCrontabString: crontab,
                dailyModeTime: `${this.padWithZero(re.exec(crontab)[2], 2)}:${this.padWithZero(re.exec(crontab)[1], 2)}`
            });
        }
        //Day of month mode
        re = /0 ([0-9]|[0-5][0-9]) ([0-9]|[0-2][0-9]) ([1-9]|0[1-9]|[1-2][0-9]|3[0-1])W? \* \?/;
        if (re.test(crontab)) {
            const minutes = this.padWithZero(re.exec(crontab)[1], 2);
            const hours = this.padWithZero(re.exec(crontab)[2], 2);
            const day = re.exec(crontab)[3];
            return new CrontabModel({
                mode: CrontabMode.EVERY_MONTH,
                outputCrontabString: crontab,
                monthlyWeekdayMode: crontab.includes("W"),
                monthlyModeTime: `${hours}:${minutes}`,
                monthlyModeDay: day
            });
        }
        //Last day of month mode
        re = /0 ([0-9]|[0-5][0-9]) ([0-9]|[0-2][0-9]) LW? \* \?/;
        if (re.test(crontab)) {
            const minutes = this.padWithZero(re.exec(crontab)[1], 2);
            const hours = this.padWithZero(re.exec(crontab)[2], 2);
            return new CrontabModel({
                mode: CrontabMode.LAST_DAY_OF_MONTH,
                outputCrontabString: crontab,
                lastWeekDayOfMonthMode: crontab.includes("LW"),
                lastDayOfMonthModeTime: `${hours}:${minutes}`
            });
        }
        //n-th weekday mode
        re = /0 ([0-9]|[0-5][0-9]) ([0-9]|[0-2][0-9]) \? \* (?<day>(?<mon>(MON|2)#[1-5])|(?<tue>(TUE|3)#[1-5])|(?<wed>(WED|4)#[1-5])|(?<thu>(THU|5)#[1-5])|(?<fri>(FRI|6)#[1-5])|(?<sat>(SAT|7)#[1-5])|(?<sun>(SUN|1)#[1-5]))/;
        if (re.test(crontab)) {
            const match = re.exec(crontab);
            const minutes = this.padWithZero(match[1], 2);
            const hours = this.padWithZero(match[2], 2);
            let dayOfWeek = match.groups['day'].split('#')[0];
            switch (dayOfWeek) {
                case "1":
                    dayOfWeek = "SUN";
                    break;
                case "2":
                    dayOfWeek = "MON";
                    break;
                case "3":
                    dayOfWeek = "TUE";
                    break;
                case "4":
                    dayOfWeek = "WED";
                    break;
                case "5":
                    dayOfWeek = "THU";
                    break;
                case "6":
                    dayOfWeek = "FRI";
                    break;
                case "7":
                    dayOfWeek = "SAT";
                    break;
                default:
                    break;
            }
            return new CrontabModel({
                mode: CrontabMode.NTH_WEEKDAY,
                outputCrontabString: crontab,
                weeklyModeTime: `${hours}:${minutes}`,
                nthDayOfWeekIndex: match.groups['day'].split('#')[1],
                nthDayOfWeekWeekday: dayOfWeek
            });
        }
        re = /0 ([0-9]|[0-5][0-9]) ([0-9]|[0-2][0-9]) \? \* (MON,?)?(TUE,?)?(WED,?)?(THU,?)?(FRI,?)?(SAT,?)?(SUN,?)?/;
        if (re.test(crontab)) {
            const minutes = this.padWithZero(re.exec(crontab)[1], 2);
            const hours = this.padWithZero(re.exec(crontab)[2], 2);
            return new CrontabModel({
                mode: CrontabMode.EVERY_WEEK,
                outputCrontabString: crontab,
                weeklyModeTime: `${hours}:${minutes}`,
                monday: crontab.includes("MON"),
                tuesday: crontab.includes("TUE"),
                wednesday: crontab.includes("WED"),
                thursday: crontab.includes("THU"),
                friday: crontab.includes("FRI"),
                saturday: crontab.includes("SAT"),
                sunday: crontab.includes("SUN"),
            });
        }
        //No match, infer custom mode
        return new CrontabModel({
            mode: CrontabMode.CUSTOM,
            outputCrontabString: crontab,
            customCrontabString: crontab
        });
    }
    padWithZero(s, desiredLength) {
        while (s.length < desiredLength) {
            s = `0${s}`;
        }
        return s;
    }
    isNullOrWhiteSpace(input) {
        return !input || !input.trim();
    }
    isValidMinutesOrSeconds(s) {
        return !this.isNullOrWhiteSpace(s) && s.match(constants.regex1to59);
    }
    isValidHours(s) {
        return !this.isNullOrWhiteSpace(s) && s.match(constants.regex1to23);
    }
    isValidTime(s) {
        return !this.isNullOrWhiteSpace(s) && s.match(constants.timestampRegex);
    }
    isValidDayOfMonth(s) {
        return !this.isNullOrWhiteSpace(s) && s.match(constants.regex1to31);
    }
    computeEverySecondCrontab(model) {
        if (this.isNullOrWhiteSpace(model.secondModeSeconds)) {
            model.secondModeSeconds = "1";
        }
        if (model.mode === CrontabMode.EVERY_X_SECONDS && this.isValidMinutesOrSeconds(model.secondModeSeconds)) {
            const seconds = Number(model.secondModeSeconds);
            model.outputCrontabString = `0/${seconds} * * 1/1 * ?`;
        }
    }
    computeEveryMinuteCrontab(model) {
        if (this.isNullOrWhiteSpace(model.minuteModeMinutes)) {
            model.minuteModeMinutes = "1";
        }
        if (model.mode === CrontabMode.EVERY_X_MINUTES && this.isValidMinutesOrSeconds(model.minuteModeMinutes)) {
            const minutes = Number(model.minuteModeMinutes);
            model.outputCrontabString = `0 0/${minutes} * 1/1 * ?`;
        }
    }
    computeEveryHourCrontab(model) {
        if (this.isNullOrWhiteSpace(model.hourlyModeHours)) {
            model.hourlyModeHours = "1";
        }
        if (model.mode === CrontabMode.EVERY_X_HOURS && this.isValidHours(model.hourlyModeHours)) {
            const hours = Number(model.hourlyModeHours);
            model.outputCrontabString = `0 0 0/${hours} 1/1 * ?`;
        }
    }
    computeEveryDayCrontab(model) {
        if (this.isNullOrWhiteSpace(model.dailyModeTime)) {
            model.dailyModeTime = "12:00";
        }
        if (model.mode === CrontabMode.EVERY_DAY && this.isValidTime(model.dailyModeTime)) {
            const minutes = Number(model.dailyModeTime.split(':')[1]);
            const hours = Number(model.dailyModeTime.split(':')[0]);
            model.outputCrontabString = `0 ${minutes} ${hours} * * ?`;
        }
    }
    computeEveryWeekDayCrontab(model) {
        if (this.isNullOrWhiteSpace(model.weeklyModeTime)) {
            model.weeklyModeTime = "12:00";
        }
        if (model.mode === CrontabMode.EVERY_WEEK && this.isValidTime(model.weeklyModeTime)) {
            const daysArray = [
                { day: "MON", selected: model.monday },
                { day: "TUE", selected: model.tuesday },
                { day: "WED", selected: model.wednesday },
                { day: "THU", selected: model.thursday },
                { day: "FRI", selected: model.friday },
                { day: "SAT", selected: model.saturday },
                { day: "SUN", selected: model.sunday }
            ];
            let days = daysArray.filter(d => d.selected)
                .map(d => d.day)
                .join(',');
            if (this.isNullOrWhiteSpace(days)) {
                days = "*";
            }
            const minutes = Number(model.weeklyModeTime.split(':')[1]);
            const hours = Number(model.weeklyModeTime.split(':')[0]);
            model.outputCrontabString = `0 ${minutes} ${hours} ? * ${days}`;
        }
    }
    computeEveryNthDayOfWeekCrontab(model) {
        if (this.isNullOrWhiteSpace(model.weeklyModeTime)) {
            model.weeklyModeTime = "12:00";
        }
        if (model.mode === CrontabMode.NTH_WEEKDAY && this.isValidTime(model.weeklyModeTime)) {
            const days = `${model.nthDayOfWeekWeekday}#${model.nthDayOfWeekIndex}`;
            const minutes = Number(model.weeklyModeTime.split(':')[1]);
            const hours = Number(model.weeklyModeTime.split(':')[0]);
            model.outputCrontabString = `0 ${minutes} ${hours} ? * ${days}`;
        }
    }
    computeNDayInMonthCrontab(model) {
        if (this.isNullOrWhiteSpace(model.monthlyModeDay)) {
            model.monthlyModeDay = "1";
        }
        if (this.isNullOrWhiteSpace(model.monthlyModeTime)) {
            model.monthlyModeTime = "12:00";
        }
        if (model.mode === CrontabMode.EVERY_MONTH && this.isValidTime(model.monthlyModeTime) && this.isValidDayOfMonth(model.monthlyModeDay)) {
            const minutes = Number(model.monthlyModeTime.split(':')[1]);
            const hours = Number(model.monthlyModeTime.split(':')[0]);
            const dayInMonth = Number(model.monthlyModeDay);
            model.outputCrontabString = `0 ${minutes} ${hours} ${dayInMonth}${model.monthlyWeekdayMode ? "W" : ""} * ?`;
        }
    }
    computeLastMonthDay(model) {
        if (this.isNullOrWhiteSpace(model.lastDayOfMonthModeTime)) {
            model.lastDayOfMonthModeTime = "12:00";
        }
        if (model.mode === CrontabMode.LAST_DAY_OF_MONTH && this.isValidTime(model.lastDayOfMonthModeTime)) {
            const minutes = Number(model.lastDayOfMonthModeTime.split(':')[1]);
            const hours = Number(model.lastDayOfMonthModeTime.split(':')[0]);
            model.outputCrontabString = `0 ${minutes} ${hours} ${model.lastWeekDayOfMonthMode ? "LW" : "L"} * ?`;
        }
    }
    computeCustom(model) {
        if (model.mode === CrontabMode.CUSTOM) {
            model.outputCrontabString = model.customCrontabString;
        }
    }
}

class NgxCrontabBuilderComponent {
    constructor() {
        //Internal references/services
        this.crontabService = new CrontabService();
        this.tr = new TranslateService('en');
        this.CrontabMode = CrontabMode;
        this.constants = constants;
        //Inputs/outputs
        this.locale = constants.defaultLocale; //language code (ISO 639-1)
        this.componentStyle = "FIELDSETS" /* ComponentStyle.FIELDSETS */;
        this.showSecondsMode = true;
        this.showMinutesMode = true;
        this.showHoursMode = true;
        this.showDailyMode = true;
        this.showWeekMode = true;
        this.showNthDayOfWeekMode = true;
        this.showMonthMode = true;
        this.showLastDayOfMonthMode = true;
        this.showCustomExpressionMode = true;
        //UI
        this.crontabModeKeys = [];
        this.activeTabIndex = 0;
        this.model = this.crontabService.parse(constants.initialCrontab, false);
    }
    //OnInit implementation
    ngOnInit() {
        this.tr.updateLocale(this.locale);
    }
    //OnChanges implementation
    ngOnChanges(changes) {
        //Update language if locale changed
        if (changes['locale']) {
            this.tr.updateLocale(this.locale);
        }
        //Update active tab if in tabbed mode
        const visibilityProps = ['showSecondsMode', 'showMinutesMode', 'showHoursMode', 'showDailyMode',
            'showWeekMode', 'showNthDayOfWeekMode', 'showMonthMode', 'showLastDayOfMonthMode', 'showCustomExpressionMode'];
        if (changes['componentStyle'] || visibilityProps.some(x => changes[x])) {
            this.crontabModeKeys = Object.keys(CrontabMode)
                .filter(x => isNaN(Number(x)))
                .map(x => x)
                .filter((x, idx) => this[visibilityProps[idx]]);
            this.updateTabIndex();
        }
    }
    //ControlValueAccessor implementation
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    writeValue(obj) {
        if (obj !== this.model.outputCrontabString) {
            this.model = this.crontabService.parse(obj, false);
            this.crontabChanged();
        }
        this.updateTabIndex();
    }
    //Component methods
    recalculateCrontab() {
        const curCrontab = this.model.outputCrontabString;
        this.crontabService.updateModel(this.model);
        if (curCrontab !== this.model.outputCrontabString) {
            this.crontabChanged();
        }
    }
    crontabChanged() {
        this.onChange && this.onChange(this.model.outputCrontabString);
        if (!this.touched) {
            this.onTouched && this.onTouched();
            this.touched = true;
        }
    }
    tabChanged(idx) {
        this.model.mode = this.crontabModeKeys[idx];
        this.recalculateCrontab();
    }
    updateTabIndex() {
        this.activeTabIndex = this.crontabModeKeys.includes(this.model.mode) ? this.crontabModeKeys.indexOf(this.model.mode) : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.11", type: NgxCrontabBuilderComponent, selector: "ngx-crontab-builder", inputs: { locale: "locale", componentStyle: "componentStyle", showSecondsMode: "showSecondsMode", showMinutesMode: "showMinutesMode", showHoursMode: "showHoursMode", showDailyMode: "showDailyMode", showWeekMode: "showWeekMode", showNthDayOfWeekMode: "showNthDayOfWeekMode", showMonthMode: "showMonthMode", showLastDayOfMonthMode: "showLastDayOfMonthMode", showCustomExpressionMode: "showCustomExpressionMode" }, providers: [
            {
                provide: NG_VALUE_ACCESSOR,
                multi: true,
                useExisting: NgxCrontabBuilderComponent
            }
        ], usesOnChanges: true, ngImport: i0, template: "<!-- FIELDSETS display mode -->\n<div *ngIf=\"componentStyle === 'FIELDSETS'\" class=\"ngx-crontab-builder-root root-fieldset flex flex-column gap-2\">\n  <p-fieldset *ngIf=\"showSecondsMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_X_SECONDS\" name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_x_seconds\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyXSeconds\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showMinutesMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_X_MINUTES\" name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_x_minutes\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyXMinutes\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showHoursMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_X_HOURS\" name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_x_hours\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyXHours\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showDailyMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\" [value]=\"CrontabMode.EVERY_DAY\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_day\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyDay\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showWeekMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_WEEK\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_week\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyWeek\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showNthDayOfWeekMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.NTH_WEEKDAY\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_nth_day\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyNthDayOfWeek\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showMonthMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_MONTH\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_month\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyMonth\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showLastDayOfMonthMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.LAST_DAY_OF_MONTH\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_last_day_of_month\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"lastDayOfMonth\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showCustomExpressionMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.CUSTOM\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_custom_cron\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"customCrontab\"></ng-template>\n  </p-fieldset>\n</div>\n\n<!-- PLAIN display mode -->\n<div *ngIf=\"componentStyle === 'PLAIN'\" class=\"ngx-crontab-builder-root root-plain flex flex-column gap-2\">\n  <p-divider *ngIf=\"showSecondsMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_X_SECONDS\" name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_x_seconds\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyXSeconds\" *ngIf=\"showSecondsMode\"></ng-template>\n\n  <p-divider *ngIf=\"showMinutesMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_X_MINUTES\" name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_x_minutes\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyXMinutes\" *ngIf=\"showMinutesMode\"></ng-template>\n\n  <p-divider *ngIf=\"showHoursMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_X_HOURS\" name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_x_hours\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyXHours\" *ngIf=\"showHoursMode\"></ng-template>\n\n  <p-divider *ngIf=\"showDailyMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\" [value]=\"CrontabMode.EVERY_DAY\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_day\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyDay\" *ngIf=\"showDailyMode\"></ng-template>\n\n  <p-divider *ngIf=\"showWeekMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_WEEK\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_week\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyWeek\" *ngIf=\"showWeekMode\"></ng-template>\n\n  <p-divider *ngIf=\"showNthDayOfWeekMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.NTH_WEEKDAY\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_nth_day\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyNthDayOfWeek\" *ngIf=\"showNthDayOfWeekMode\"></ng-template>\n\n  <p-divider *ngIf=\"showMonthMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_MONTH\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_month\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyMonth\" *ngIf=\"showMonthMode\"></ng-template>\n\n  <p-divider *ngIf=\"showLastDayOfMonthMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.LAST_DAY_OF_MONTH\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_last_day_of_month\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"lastDayOfMonth\" *ngIf=\"showLastDayOfMonthMode\"></ng-template>\n\n  <p-divider *ngIf=\"showCustomExpressionMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.CUSTOM\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_custom_cron\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"customCrontab\" *ngIf=\"showCustomExpressionMode\"></ng-template>\n</div>\n\n<!-- TABBED display mode -->\n<div *ngIf=\"componentStyle === 'TABBED'\" class=\"ngx-crontab-builder-root root-fieldset flex flex-column gap-2\">\n  <p-tabView [scrollable]=\"true\" [activeIndex]=\"activeTabIndex\" (activeIndexChange)=\"tabChanged($event)\">\n    <p-tabPanel *ngIf=\"showSecondsMode\" [header]=\"tr.locale.header_every_x_seconds\">\n      <ng-template [ngTemplateOutlet]=\"everyXSeconds\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showMinutesMode\" [header]=\"tr.locale.header_every_x_minutes\">\n      <ng-template [ngTemplateOutlet]=\"everyXMinutes\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showHoursMode\" [header]=\"tr.locale.header_every_x_hours\">\n      <ng-template [ngTemplateOutlet]=\"everyXHours\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showDailyMode\" [header]=\"tr.locale.header_every_day\">\n      <ng-template [ngTemplateOutlet]=\"everyDay\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showWeekMode\" [header]=\"tr.locale.header_every_week\">\n      <ng-template [ngTemplateOutlet]=\"everyWeek\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showNthDayOfWeekMode\" [header]=\"tr.locale.header_every_nth_day\">\n      <ng-template [ngTemplateOutlet]=\"everyNthDayOfWeek\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showMonthMode\" [header]=\"tr.locale.header_every_month\">\n      <ng-template [ngTemplateOutlet]=\"everyMonth\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showLastDayOfMonthMode\" [header]=\"tr.locale.header_every_last_day_of_month\">\n      <ng-template [ngTemplateOutlet]=\"lastDayOfMonth\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showCustomExpressionMode\" [header]=\"tr.locale.header_custom_cron\">\n      <ng-template [ngTemplateOutlet]=\"customCrontab\"></ng-template>\n    </p-tabPanel>\n  </p-tabView>\n</div>\n\n<!-- Actual editor components -->\n<ng-template #everyXSeconds>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_X_SECONDS}\">\n    <div class=\"disable-check\">{{tr.locale.run_every}}</div>\n    <input pInputText [(ngModel)]=\"model.secondModeSeconds\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.regex1to59\" [disabled]=\"model.mode !== CrontabMode.EVERY_X_SECONDS\">\n    <div class=\"disable-check\">{{tr.locale.seconds}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyXMinutes>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_X_MINUTES}\">\n    <div>{{tr.locale.run_every}}</div>\n    <input pInputText [(ngModel)]=\"model.minuteModeMinutes\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.regex1to59\" [disabled]=\"model.mode !== CrontabMode.EVERY_X_MINUTES\">\n    <div>{{tr.locale.minutes}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyXHours>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_X_HOURS}\">\n    <div>{{tr.locale.run_every}}</div>\n    <input pInputText [(ngModel)]=\"model.hourlyModeHours\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.regex1to23\" [disabled]=\"model.mode !== CrontabMode.EVERY_X_HOURS\">\n    <div>{{tr.locale.hours}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyDay>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_DAY}\">\n    <div>{{tr.locale.run_every_day_at}}</div>\n    <input pInputText [(ngModel)]=\"model.dailyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.EVERY_DAY\">\n    <div>{{tr.locale.time_format_info}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyWeek>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_WEEK}\">\n    <div>{{tr.locale.run_every_week_on_day}}</div>\n    <div class=\"flex flex-row align-items-center gap-1\">\n      <p-checkbox [(ngModel)]=\"model.monday\" [label]=\"tr.locale.day_mon\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.tuesday\" [label]=\"tr.locale.day_tue\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.wednesday\" [label]=\"tr.locale.day_wed\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.thursday\" [label]=\"tr.locale.day_thu\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.friday\" [label]=\"tr.locale.day_fri\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.saturday\" [label]=\"tr.locale.day_sat\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.sunday\" [label]=\"tr.locale.day_sun\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n    </div>\n    <div>{{tr.locale.at}}</div>\n    <input pInputText [(ngModel)]=\"model.weeklyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\">\n    <div>{{tr.locale.time_format_info}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyNthDayOfWeek>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.NTH_WEEKDAY}\">\n    <div>{{tr.locale.run_every}}</div>\n    <p-dropdown [options]=\"tr.localizedWeekOrdinals\" [(ngModel)]=\"model.nthDayOfWeekIndex\" optionLabel=\"label\"\n                optionValue=\"value\" appendTo=\"body\"\n                (ngModelChange)=\"recalculateCrontab()\"\n                [disabled]=\"model.mode !== CrontabMode.NTH_WEEKDAY\"></p-dropdown>\n    <p-dropdown [options]=\"tr.localizedWeekDays\" [(ngModel)]=\"model.nthDayOfWeekWeekday\" optionLabel=\"label\"\n                optionValue=\"value\"\n                (ngModelChange)=\"recalculateCrontab()\"\n                [disabled]=\"model.mode !== CrontabMode.NTH_WEEKDAY\"></p-dropdown>\n    <div>{{tr.locale.of_the_week_at}}</div>\n    <input pInputText [(ngModel)]=\"model.weeklyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.NTH_WEEKDAY\">\n    <div>{{tr.locale.time_format_info}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyMonth>\n  <div class=\"flex flex-column gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_MONTH}\">\n    <div class=\"flex flex-row align-items-center gap-2\">\n      <div>{{tr.locale.run_every_month_on_day}}</div>\n      <input pInputText [(ngModel)]=\"model.monthlyModeDay\" (ngModelChange)=\"recalculateCrontab()\"\n              [disabled]=\"model.mode !== CrontabMode.EVERY_MONTH\">\n      <div>(1-31) {{tr.locale.of_the_week_at}}</div>\n      <input pInputText [(ngModel)]=\"model.monthlyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n             [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.EVERY_MONTH\">\n      <div>{{tr.locale.time_format_info}}</div>\n    </div>\n\n    <div>\n      <p-checkbox [(ngModel)]=\"model.monthlyWeekdayMode\" [binary]=\"true\" [label]=\"tr.locale.nearest_weekday_option\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_MONTH\"></p-checkbox>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #lastDayOfMonth>\n  <div class=\"flex flex-column gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.LAST_DAY_OF_MONTH}\">\n    <div class=\"flex flex-row align-items-center gap-2\">\n      <div>{{tr.locale.run_on_last_day_of_month}}</div>\n      <div>(1-31) {{tr.locale.at}}</div>\n      <input pInputText [(ngModel)]=\"model.lastDayOfMonthModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n             [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.LAST_DAY_OF_MONTH\">\n      <div>{{tr.locale.time_format_info}}</div>\n    </div>\n\n    <div>\n      <p-checkbox [(ngModel)]=\"model.lastWeekDayOfMonthMode\" [binary]=\"true\"\n                  [label]=\"tr.locale.last_weekday_of_month_option\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.LAST_DAY_OF_MONTH\"></p-checkbox>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #customCrontab>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.CUSTOM}\">\n    <div>{{tr.locale.use_custom_crontab}}</div>\n    <input pInputText [(ngModel)]=\"model.customCrontabString\" (ngModelChange)=\"recalculateCrontab()\"\n           [disabled]=\"model.mode !== CrontabMode.CUSTOM\">\n  </div>\n</ng-template>\n", styles: [".ngx-crontab-builder-root .p-fieldset-legend{padding:.5rem!important}.ngx-crontab-builder-root .p-fieldset-content{padding:.2rem!important}.ngx-crontab-builder-root .p-divider.p-divider-horizontal{margin:.5rem 0!important}.ngx-crontab-builder-root .disabled{opacity:.6!important;cursor:default!important}\n"], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.PatternValidator, selector: "[pattern][formControlName],[pattern][formControl],[pattern][ngModel]", inputs: ["pattern"] }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: i3.InputText, selector: "[pInputText]", inputs: ["variant"] }, { kind: "component", type: i4.Fieldset, selector: "p-fieldset", inputs: ["legend", "toggleable", "collapsed", "style", "styleClass", "transitionOptions"], outputs: ["collapsedChange", "onBeforeToggle", "onAfterToggle"] }, { kind: "directive", type: i5.PrimeTemplate, selector: "[pTemplate]", inputs: ["type", "pTemplate"] }, { kind: "component", type: i6.RadioButton, selector: "p-radioButton", inputs: ["value", "formControlName", "name", "disabled", "label", "variant", "tabindex", "inputId", "ariaLabelledBy", "ariaLabel", "style", "styleClass", "labelStyleClass", "autofocus"], outputs: ["onClick", "onFocus", "onBlur"] }, { kind: "component", type: i7.Checkbox, selector: "p-checkbox", inputs: ["value", "name", "disabled", "binary", "label", "ariaLabelledBy", "ariaLabel", "tabindex", "inputId", "style", "styleClass", "labelStyleClass", "formControl", "checkboxIcon", "readonly", "required", "autofocus", "trueValue", "falseValue", "variant"], outputs: ["onChange", "onFocus", "onBlur"] }, { kind: "component", type: i8.Dropdown, selector: "p-dropdown", inputs: ["id", "scrollHeight", "filter", "name", "style", "panelStyle", "styleClass", "panelStyleClass", "readonly", "required", "editable", "appendTo", "tabindex", "placeholder", "loadingIcon", "filterPlaceholder", "filterLocale", "variant", "inputId", "dataKey", "filterBy", "filterFields", "autofocus", "resetFilterOnHide", "checkmark", "dropdownIcon", "loading", "optionLabel", "optionValue", "optionDisabled", "optionGroupLabel", "optionGroupChildren", "autoDisplayFirst", "group", "showClear", "emptyFilterMessage", "emptyMessage", "lazy", "virtualScroll", "virtualScrollItemSize", "virtualScrollOptions", "overlayOptions", "ariaFilterLabel", "ariaLabel", "ariaLabelledBy", "filterMatchMode", "maxlength", "tooltip", "tooltipPosition", "tooltipPositionStyle", "tooltipStyleClass", "focusOnHover", "selectOnFocus", "autoOptionFocus", "autofocusFilter", "disabled", "itemSize", "autoZIndex", "baseZIndex", "showTransitionOptions", "hideTransitionOptions", "filterValue", "options"], outputs: ["onChange", "onFilter", "onFocus", "onBlur", "onClick", "onShow", "onHide", "onClear", "onLazyLoad"] }, { kind: "component", type: i9.Divider, selector: "p-divider", inputs: ["style", "styleClass", "layout", "type", "align"] }, { kind: "component", type: i10.TabView, selector: "p-tabView", inputs: ["style", "styleClass", "controlClose", "scrollable", "activeIndex", "selectOnFocus", "nextButtonAriaLabel", "prevButtonAriaLabel", "autoHideButtons", "tabindex"], outputs: ["onChange", "onClose", "activeIndexChange"] }, { kind: "component", type: i10.TabPanel, selector: "p-tabPanel", inputs: ["closable", "headerStyle", "headerStyleClass", "cache", "tooltip", "tooltipPosition", "tooltipPositionStyle", "tooltipStyleClass", "selected", "disabled", "header", "leftIcon", "rightIcon"] }], encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-crontab-builder', encapsulation: ViewEncapsulation.None, providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            multi: true,
                            useExisting: NgxCrontabBuilderComponent
                        }
                    ], template: "<!-- FIELDSETS display mode -->\n<div *ngIf=\"componentStyle === 'FIELDSETS'\" class=\"ngx-crontab-builder-root root-fieldset flex flex-column gap-2\">\n  <p-fieldset *ngIf=\"showSecondsMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_X_SECONDS\" name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_x_seconds\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyXSeconds\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showMinutesMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_X_MINUTES\" name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_x_minutes\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyXMinutes\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showHoursMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_X_HOURS\" name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_x_hours\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyXHours\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showDailyMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\" [value]=\"CrontabMode.EVERY_DAY\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_day\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyDay\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showWeekMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_WEEK\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_week\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyWeek\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showNthDayOfWeekMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.NTH_WEEKDAY\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_nth_day\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyNthDayOfWeek\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showMonthMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.EVERY_MONTH\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_month\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"everyMonth\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showLastDayOfMonthMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.LAST_DAY_OF_MONTH\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_every_last_day_of_month\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"lastDayOfMonth\"></ng-template>\n  </p-fieldset>\n\n  <p-fieldset *ngIf=\"showCustomExpressionMode\">\n    <ng-template pTemplate=\"header\">\n      <p-radioButton [(ngModel)]=\"model.mode\" (onClick)=\"recalculateCrontab()\"\n                     [value]=\"CrontabMode.CUSTOM\"\n                     name=\"crontabmode\"\n                     [label]=\"tr.locale.header_custom_cron\"></p-radioButton>\n    </ng-template>\n\n    <ng-template [ngTemplateOutlet]=\"customCrontab\"></ng-template>\n  </p-fieldset>\n</div>\n\n<!-- PLAIN display mode -->\n<div *ngIf=\"componentStyle === 'PLAIN'\" class=\"ngx-crontab-builder-root root-plain flex flex-column gap-2\">\n  <p-divider *ngIf=\"showSecondsMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_X_SECONDS\" name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_x_seconds\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyXSeconds\" *ngIf=\"showSecondsMode\"></ng-template>\n\n  <p-divider *ngIf=\"showMinutesMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_X_MINUTES\" name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_x_minutes\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyXMinutes\" *ngIf=\"showMinutesMode\"></ng-template>\n\n  <p-divider *ngIf=\"showHoursMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_X_HOURS\" name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_x_hours\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyXHours\" *ngIf=\"showHoursMode\"></ng-template>\n\n  <p-divider *ngIf=\"showDailyMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\" [value]=\"CrontabMode.EVERY_DAY\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_day\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyDay\" *ngIf=\"showDailyMode\"></ng-template>\n\n  <p-divider *ngIf=\"showWeekMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_WEEK\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_week\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyWeek\" *ngIf=\"showWeekMode\"></ng-template>\n\n  <p-divider *ngIf=\"showNthDayOfWeekMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.NTH_WEEKDAY\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_nth_day\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyNthDayOfWeek\" *ngIf=\"showNthDayOfWeekMode\"></ng-template>\n\n  <p-divider *ngIf=\"showMonthMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.EVERY_MONTH\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_month\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"everyMonth\" *ngIf=\"showMonthMode\"></ng-template>\n\n  <p-divider *ngIf=\"showLastDayOfMonthMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.LAST_DAY_OF_MONTH\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_every_last_day_of_month\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"lastDayOfMonth\" *ngIf=\"showLastDayOfMonthMode\"></ng-template>\n\n  <p-divider *ngIf=\"showCustomExpressionMode\">\n    <p-radioButton [(ngModel)]=\"model.mode\" (ngModelChange)=\"recalculateCrontab()\"\n                   [value]=\"CrontabMode.CUSTOM\"\n                   name=\"crontabmode\"\n                   [label]=\"tr.locale.header_custom_cron\" labelStyleClass=\"font-bold\"></p-radioButton>\n  </p-divider>\n  <ng-template [ngTemplateOutlet]=\"customCrontab\" *ngIf=\"showCustomExpressionMode\"></ng-template>\n</div>\n\n<!-- TABBED display mode -->\n<div *ngIf=\"componentStyle === 'TABBED'\" class=\"ngx-crontab-builder-root root-fieldset flex flex-column gap-2\">\n  <p-tabView [scrollable]=\"true\" [activeIndex]=\"activeTabIndex\" (activeIndexChange)=\"tabChanged($event)\">\n    <p-tabPanel *ngIf=\"showSecondsMode\" [header]=\"tr.locale.header_every_x_seconds\">\n      <ng-template [ngTemplateOutlet]=\"everyXSeconds\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showMinutesMode\" [header]=\"tr.locale.header_every_x_minutes\">\n      <ng-template [ngTemplateOutlet]=\"everyXMinutes\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showHoursMode\" [header]=\"tr.locale.header_every_x_hours\">\n      <ng-template [ngTemplateOutlet]=\"everyXHours\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showDailyMode\" [header]=\"tr.locale.header_every_day\">\n      <ng-template [ngTemplateOutlet]=\"everyDay\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showWeekMode\" [header]=\"tr.locale.header_every_week\">\n      <ng-template [ngTemplateOutlet]=\"everyWeek\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showNthDayOfWeekMode\" [header]=\"tr.locale.header_every_nth_day\">\n      <ng-template [ngTemplateOutlet]=\"everyNthDayOfWeek\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showMonthMode\" [header]=\"tr.locale.header_every_month\">\n      <ng-template [ngTemplateOutlet]=\"everyMonth\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showLastDayOfMonthMode\" [header]=\"tr.locale.header_every_last_day_of_month\">\n      <ng-template [ngTemplateOutlet]=\"lastDayOfMonth\"></ng-template>\n    </p-tabPanel>\n\n    <p-tabPanel *ngIf=\"showCustomExpressionMode\" [header]=\"tr.locale.header_custom_cron\">\n      <ng-template [ngTemplateOutlet]=\"customCrontab\"></ng-template>\n    </p-tabPanel>\n  </p-tabView>\n</div>\n\n<!-- Actual editor components -->\n<ng-template #everyXSeconds>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_X_SECONDS}\">\n    <div class=\"disable-check\">{{tr.locale.run_every}}</div>\n    <input pInputText [(ngModel)]=\"model.secondModeSeconds\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.regex1to59\" [disabled]=\"model.mode !== CrontabMode.EVERY_X_SECONDS\">\n    <div class=\"disable-check\">{{tr.locale.seconds}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyXMinutes>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_X_MINUTES}\">\n    <div>{{tr.locale.run_every}}</div>\n    <input pInputText [(ngModel)]=\"model.minuteModeMinutes\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.regex1to59\" [disabled]=\"model.mode !== CrontabMode.EVERY_X_MINUTES\">\n    <div>{{tr.locale.minutes}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyXHours>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_X_HOURS}\">\n    <div>{{tr.locale.run_every}}</div>\n    <input pInputText [(ngModel)]=\"model.hourlyModeHours\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.regex1to23\" [disabled]=\"model.mode !== CrontabMode.EVERY_X_HOURS\">\n    <div>{{tr.locale.hours}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyDay>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_DAY}\">\n    <div>{{tr.locale.run_every_day_at}}</div>\n    <input pInputText [(ngModel)]=\"model.dailyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.EVERY_DAY\">\n    <div>{{tr.locale.time_format_info}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyWeek>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_WEEK}\">\n    <div>{{tr.locale.run_every_week_on_day}}</div>\n    <div class=\"flex flex-row align-items-center gap-1\">\n      <p-checkbox [(ngModel)]=\"model.monday\" [label]=\"tr.locale.day_mon\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.tuesday\" [label]=\"tr.locale.day_tue\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.wednesday\" [label]=\"tr.locale.day_wed\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.thursday\" [label]=\"tr.locale.day_thu\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.friday\" [label]=\"tr.locale.day_fri\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.saturday\" [label]=\"tr.locale.day_sat\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n      <p-checkbox [(ngModel)]=\"model.sunday\" [label]=\"tr.locale.day_sun\" [binary]=\"true\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\"></p-checkbox>\n    </div>\n    <div>{{tr.locale.at}}</div>\n    <input pInputText [(ngModel)]=\"model.weeklyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.EVERY_WEEK\">\n    <div>{{tr.locale.time_format_info}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyNthDayOfWeek>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.NTH_WEEKDAY}\">\n    <div>{{tr.locale.run_every}}</div>\n    <p-dropdown [options]=\"tr.localizedWeekOrdinals\" [(ngModel)]=\"model.nthDayOfWeekIndex\" optionLabel=\"label\"\n                optionValue=\"value\" appendTo=\"body\"\n                (ngModelChange)=\"recalculateCrontab()\"\n                [disabled]=\"model.mode !== CrontabMode.NTH_WEEKDAY\"></p-dropdown>\n    <p-dropdown [options]=\"tr.localizedWeekDays\" [(ngModel)]=\"model.nthDayOfWeekWeekday\" optionLabel=\"label\"\n                optionValue=\"value\"\n                (ngModelChange)=\"recalculateCrontab()\"\n                [disabled]=\"model.mode !== CrontabMode.NTH_WEEKDAY\"></p-dropdown>\n    <div>{{tr.locale.of_the_week_at}}</div>\n    <input pInputText [(ngModel)]=\"model.weeklyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n           [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.NTH_WEEKDAY\">\n    <div>{{tr.locale.time_format_info}}</div>\n  </div>\n</ng-template>\n\n<ng-template #everyMonth>\n  <div class=\"flex flex-column gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.EVERY_MONTH}\">\n    <div class=\"flex flex-row align-items-center gap-2\">\n      <div>{{tr.locale.run_every_month_on_day}}</div>\n      <input pInputText [(ngModel)]=\"model.monthlyModeDay\" (ngModelChange)=\"recalculateCrontab()\"\n              [disabled]=\"model.mode !== CrontabMode.EVERY_MONTH\">\n      <div>(1-31) {{tr.locale.of_the_week_at}}</div>\n      <input pInputText [(ngModel)]=\"model.monthlyModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n             [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.EVERY_MONTH\">\n      <div>{{tr.locale.time_format_info}}</div>\n    </div>\n\n    <div>\n      <p-checkbox [(ngModel)]=\"model.monthlyWeekdayMode\" [binary]=\"true\" [label]=\"tr.locale.nearest_weekday_option\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.EVERY_MONTH\"></p-checkbox>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #lastDayOfMonth>\n  <div class=\"flex flex-column gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.LAST_DAY_OF_MONTH}\">\n    <div class=\"flex flex-row align-items-center gap-2\">\n      <div>{{tr.locale.run_on_last_day_of_month}}</div>\n      <div>(1-31) {{tr.locale.at}}</div>\n      <input pInputText [(ngModel)]=\"model.lastDayOfMonthModeTime\" (ngModelChange)=\"recalculateCrontab()\"\n             [pattern]=\"constants.timestampRegex\" [disabled]=\"model.mode !== CrontabMode.LAST_DAY_OF_MONTH\">\n      <div>{{tr.locale.time_format_info}}</div>\n    </div>\n\n    <div>\n      <p-checkbox [(ngModel)]=\"model.lastWeekDayOfMonthMode\" [binary]=\"true\"\n                  [label]=\"tr.locale.last_weekday_of_month_option\"\n                  (ngModelChange)=\"recalculateCrontab()\"\n                  [disabled]=\"model.mode !== CrontabMode.LAST_DAY_OF_MONTH\"></p-checkbox>\n    </div>\n  </div>\n</ng-template>\n\n<ng-template #customCrontab>\n  <div class=\"flex flex-row align-items-center gap-2\" [ngClass]=\"{'disabled': model.mode !== CrontabMode.CUSTOM}\">\n    <div>{{tr.locale.use_custom_crontab}}</div>\n    <input pInputText [(ngModel)]=\"model.customCrontabString\" (ngModelChange)=\"recalculateCrontab()\"\n           [disabled]=\"model.mode !== CrontabMode.CUSTOM\">\n  </div>\n</ng-template>\n", styles: [".ngx-crontab-builder-root .p-fieldset-legend{padding:.5rem!important}.ngx-crontab-builder-root .p-fieldset-content{padding:.2rem!important}.ngx-crontab-builder-root .p-divider.p-divider-horizontal{margin:.5rem 0!important}.ngx-crontab-builder-root .disabled{opacity:.6!important;cursor:default!important}\n"] }]
        }], ctorParameters: () => [], propDecorators: { locale: [{
                type: Input
            }], componentStyle: [{
                type: Input
            }], showSecondsMode: [{
                type: Input
            }], showMinutesMode: [{
                type: Input
            }], showHoursMode: [{
                type: Input
            }], showDailyMode: [{
                type: Input
            }], showWeekMode: [{
                type: Input
            }], showNthDayOfWeekMode: [{
                type: Input
            }], showMonthMode: [{
                type: Input
            }], showLastDayOfMonthMode: [{
                type: Input
            }], showCustomExpressionMode: [{
                type: Input
            }] } });

class NgxCrontabBuilderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderModule, declarations: [NgxCrontabBuilderComponent], imports: [CommonModule,
            FormsModule,
            InputTextModule,
            FieldsetModule,
            RadioButtonModule,
            CheckboxModule,
            DropdownModule,
            DividerModule,
            InputNumberModule,
            TabViewModule,
            KeyFilterModule,
            NgTemplateOutlet], exports: [NgxCrontabBuilderComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderModule, imports: [CommonModule,
            FormsModule,
            InputTextModule,
            FieldsetModule,
            RadioButtonModule,
            CheckboxModule,
            DropdownModule,
            DividerModule,
            InputNumberModule,
            TabViewModule,
            KeyFilterModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.11", ngImport: i0, type: NgxCrontabBuilderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgxCrontabBuilderComponent
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        InputTextModule,
                        FieldsetModule,
                        RadioButtonModule,
                        CheckboxModule,
                        DropdownModule,
                        DividerModule,
                        InputNumberModule,
                        TabViewModule,
                        KeyFilterModule,
                        NgTemplateOutlet
                    ],
                    exports: [
                        NgxCrontabBuilderComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-crontab-builder
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxCrontabBuilderComponent, NgxCrontabBuilderModule, NgxCrontabBuilderService };
//# sourceMappingURL=ngx-crontab-builder.mjs.map
