import { OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { TranslateService } from "./services/translate.service";
import { CrontabMode } from "./models/crontab-mode";
import { CrontabModel } from "./models/crontab-model";
import { ComponentStyle } from "./models/component-style";
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
export declare class NgxCrontabBuilderComponent implements OnInit, OnChanges, ControlValueAccessor {
    private crontabService;
    tr: TranslateService;
    CrontabMode: typeof CrontabMode;
    constants: {
        regex1to59: RegExp;
        regex1to23: RegExp;
        regex1to31: RegExp;
        timestampRegex: RegExp;
        initialCrontab: string;
        defaultLocale: string;
    };
    model: CrontabModel;
    locale: string;
    componentStyle: ComponentStyle;
    showSecondsMode: boolean;
    showMinutesMode: boolean;
    showHoursMode: boolean;
    showDailyMode: boolean;
    showWeekMode: boolean;
    showNthDayOfWeekMode: boolean;
    showMonthMode: boolean;
    showLastDayOfMonthMode: boolean;
    showCustomExpressionMode: boolean;
    crontabModeKeys: CrontabMode[];
    activeTabIndex: number;
    disabled: boolean;
    private touched;
    private onTouched;
    private onChange;
    constructor();
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(obj: string): void;
    recalculateCrontab(): void;
    crontabChanged(): void;
    tabChanged(idx: number): void;
    updateTabIndex(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxCrontabBuilderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxCrontabBuilderComponent, "ngx-crontab-builder", never, { "locale": { "alias": "locale"; "required": false; }; "componentStyle": { "alias": "componentStyle"; "required": false; }; "showSecondsMode": { "alias": "showSecondsMode"; "required": false; }; "showMinutesMode": { "alias": "showMinutesMode"; "required": false; }; "showHoursMode": { "alias": "showHoursMode"; "required": false; }; "showDailyMode": { "alias": "showDailyMode"; "required": false; }; "showWeekMode": { "alias": "showWeekMode"; "required": false; }; "showNthDayOfWeekMode": { "alias": "showNthDayOfWeekMode"; "required": false; }; "showMonthMode": { "alias": "showMonthMode"; "required": false; }; "showLastDayOfMonthMode": { "alias": "showLastDayOfMonthMode"; "required": false; }; "showCustomExpressionMode": { "alias": "showCustomExpressionMode"; "required": false; }; }, {}, never, never, false, never>;
}
